/*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
 * WARRANTY OF ANY KIND, either express or implied. See the License for the specific
 * language governing rights and limitations under the License.
 * 
 * The Original Code is the Venice Web Communities System.
 * 
 * The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
 * for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
 * Copyright (C) 2001 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
 * 
 * Contributor(s): 
 */
package com.silverwrist.venice.servlets.format;

import java.util.*;
import java.io.Writer;
import java.io.IOException;
import com.silverwrist.venice.core.SIGContext;

public class SIGAdminTop extends ContentMenuPanel
{
  /*--------------------------------------------------------------------------------
   * Constructors
   *--------------------------------------------------------------------------------
   */

  public SIGAdminTop()
  {
    super("SIG Administration:",null);
    addChoice("SIG Profile","sigadmin?sig=$s&cmd=P");
    addChoice("Set SIG Category","sigadmin?sig=$s&cmd=T");
    addChoice("Set SIG Features","sigadmin?sig=$s&cmd=F");
    addChoice("Membership Control","sigadmin?sig=$s&cmd=M");
    addChoice("Display Audit Records","sigadmin?sig=$s&cmd=A");
    // TODO: More options
    addChoice("Delete SIG","sigadmin?sig=$s&cmd=DEL");

  } // end constructor

  protected SIGAdminTop(SIGAdminTop other)
  {
    super(other);

  } // end constructor

  /*--------------------------------------------------------------------------------
   * External operations
   *--------------------------------------------------------------------------------
   */

  public void setSIG(SIGContext sig)
  {
    setSubtitle(sig.getName());
    setParameter("s",String.valueOf(sig.getSIGID()));

  } // end setSIG

  public Object clone()
  {
    return new SIGAdminTop(this);

  } // end clone

} // end class SIGAdminTop
